Index: src/language/data-io/get.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/get.c,v
retrieving revision 1.26
diff -u -p -r1.26 get.c
--- src/language/data-io/get.c	15 Dec 2006 00:16:02 -0000	1.26
+++ src/language/data-io/get.c	17 Dec 2006 06:28:27 -0000
@@ -177,44 +177,33 @@ case_reader_pgm_free (struct case_reader
     }
 }
 
-/* Clears internal state related to case reader input procedure. */
-static void
-case_reader_source_destroy (struct case_source *source)
+/* Reads one case into C.
+   Returns true if successful, false at end of file or if an
+   I/O error occurred. */
+static bool
+case_reader_source_read (struct case_source *source, struct ccase *c)
 {
   struct case_reader_pgm *pgm = source->aux;
-  case_reader_pgm_free (pgm);
+  if (any_reader_read (pgm->reader, pgm->map == NULL ? c : &pgm->bounce)) 
+    {
+      if (pgm->map != NULL)
+        map_case (pgm->map, &pgm->bounce, c);
+      return true;
+    }
+  else  
+    return false;
 }
 
-/* Reads all the cases from the data file into C and passes them
-   to WRITE_CASE one by one, passing WC_DATA.
-   Returns true if successful, false if an I/O error occurred. */
+/* Destroys the source.
+   Returns true if successful read, false if an I/O occurred
+   during destruction or previously. */
 static bool
-case_reader_source_read (struct case_source *source,
-                         struct ccase *c,
-                         write_case_func *write_case, write_case_data wc_data)
+case_reader_source_destroy (struct case_source *source)
 {
   struct case_reader_pgm *pgm = source->aux;
-  bool ok = true;
-
-  do
-    {
-      bool got_case;
-      if (pgm->map == NULL)
-        got_case = any_reader_read (pgm->reader, c);
-      else
-        {
-          got_case = any_reader_read (pgm->reader, &pgm->bounce);
-          if (got_case)
-            map_case (pgm->map, &pgm->bounce, c);
-        }
-      if (!got_case)
-        break;
-
-      ok = write_case (wc_data);
-    }
-  while (ok);
-
-  return ok && !any_reader_error (pgm->reader);
+  bool ok = !any_reader_error (pgm->reader); 
+  case_reader_pgm_free (pgm);
+  return ok;
 }
 
 static const struct case_source_class case_reader_source_class =
@@ -470,8 +459,6 @@ case_writer_write_case (struct case_writ
 
 /* SAVE and EXPORT. */
 
-static bool output_proc (const struct ccase *, void *, const struct dataset *);
-
 /* Parses and performs the SAVE or EXPORT procedure. */
 static int
 parse_output_proc (struct lexer *lexer, struct dataset *ds, enum writer_type writer_type)
@@ -479,7 +466,8 @@ parse_output_proc (struct lexer *lexer, 
   bool retain_unselected;
   struct variable *saved_filter_variable;
   struct case_writer *aw;
-  bool ok;
+  struct ccase *c;
+  bool ok = true;
 
   aw = parse_write_command (lexer, ds, writer_type, PROC_CMD, &retain_unselected);
   if (aw == NULL) 
@@ -488,21 +476,18 @@ parse_output_proc (struct lexer *lexer, 
   saved_filter_variable = dict_get_filter (dataset_dict (ds));
   if (retain_unselected) 
     dict_set_filter (dataset_dict (ds), NULL);
-  ok = procedure (ds, output_proc, aw);
+
+  proc_open (ds);
+  while (ok && proc_read (ds, &c))
+    ok = case_writer_write_case (aw, c);
+  ok = proc_close (ds) && ok;
+
   dict_set_filter (dataset_dict (ds), saved_filter_variable);
 
   case_writer_destroy (aw);
   return ok ? CMD_SUCCESS : CMD_CASCADING_FAILURE;
 }
 
-/* Writes case C to file. */
-static bool
-output_proc (const struct ccase *c, void *aw_, const struct dataset *ds UNUSED) 
-{
-  struct case_writer *aw = aw_;
-  return case_writer_write_case (aw, c);
-}
-
 int
 cmd_save (struct lexer *lexer, struct dataset *ds) 
 {
@@ -771,7 +756,8 @@ struct mtf_file
     char *in_name;              /* Variable name. */
     struct variable *in_var;    /* Variable (in master dictionary). */
 
-    struct ccase input;         /* Input record. */
+    struct ccase input_storage; /* Input record storage. */
+    struct ccase *input;        /* Input record. */
   };
 
 /* MATCH FILES procedure. */
@@ -798,11 +784,10 @@ struct mtf_proc 
 static bool mtf_free (struct mtf_proc *);
 static bool mtf_close_file (struct mtf_file *);
 static int mtf_merge_dictionary (struct dictionary *const, struct mtf_file *);
+static bool mtf_read_records (struct mtf_proc *, struct dataset *);
 static bool mtf_delete_file_in_place (struct mtf_proc *, struct mtf_file **);
 
-static bool mtf_read_nonactive_records (void *);
-static bool mtf_processing_finish (void *, const struct dataset *);
-static bool mtf_processing (const struct ccase *, void *, const struct dataset *);
+static bool mtf_processing (struct mtf_proc *, struct dataset *);
 
 static char *var_type_description (struct variable *);
 
@@ -821,8 +806,6 @@ cmd_match_files (struct lexer *lexer, st
   bool saw_table = false;
   bool saw_in = false;
 
-  bool ok;
-  
   mtf.head = mtf.tail = NULL;
   mtf.by_cnt = 0;
   mtf.first[0] = '\0';
@@ -858,7 +841,8 @@ cmd_match_files (struct lexer *lexer, st
       file->dict = NULL;
       file->in_name = NULL;
       file->in_var = NULL;
-      case_nullify (&file->input);
+      case_nullify (&file->input_storage);
+      file->input = &file->input_storage;
 
       /* FILEs go first, then TABLEs. */
       if (file->type == MTF_TABLE || first_table == NULL)
@@ -923,7 +907,8 @@ cmd_match_files (struct lexer *lexer, st
           if (file->reader == NULL)
             goto error;
 
-          case_create (&file->input, dict_get_next_value_idx (file->dict));
+          case_create (&file->input_storage,
+                       dict_get_next_value_idx (file->dict));
         }
 
       while (lex_match (lexer, '/'))
@@ -1119,16 +1104,17 @@ cmd_match_files (struct lexer *lexer, st
 
      7. Repeat from step 2.
 
-     Unfortunately, this algorithm can't be implemented in a
-     straightforward way because there's no function to read a
-     record from the active file.  Instead, it has to be written
-     as a state machine.
-
      FIXME: For merging large numbers of files (more than 10?) a
      better algorithm would use a heap for finding minimum
      values. */
 
-  if (!used_active_file)
+  if (used_active_file) 
+    {
+      proc_set_sink (ds, create_case_sink (&null_sink_class, 
+                                           dataset_dict (ds), NULL));
+      proc_open (ds); 
+    }
+  else
     discard_variables (ds);
 
   dict_compact_values (mtf.dict);
@@ -1136,20 +1122,13 @@ cmd_match_files (struct lexer *lexer, st
   mtf.seq_nums = xcalloc (dict_get_var_cnt (mtf.dict), sizeof *mtf.seq_nums);
   case_create (&mtf.mtf_case, dict_get_next_value_idx (mtf.dict));
 
-  if (!mtf_read_nonactive_records (&mtf))
+  if (!mtf_read_records (&mtf, ds))
+    goto error;
+  while (mtf.head && mtf.head->type == MTF_FILE)
+    if (!mtf_processing (&mtf, ds))
+      goto error;
+  if (!proc_close (ds))
     goto error;
-
-  if (used_active_file) 
-    {
-      proc_set_sink (ds, 
-		     create_case_sink (&null_sink_class, 
-				       dataset_dict (ds), NULL));
-      ok = 
-	( procedure (ds, mtf_processing, &mtf) && 
-	  mtf_processing_finish (&mtf, ds) ); 
-    }
-  else
-    ok = mtf_processing_finish (&mtf, ds);
 
   discard_variables (ds);
 
@@ -1159,38 +1138,14 @@ cmd_match_files (struct lexer *lexer, st
   proc_set_source (ds, storage_source_create (mtf.output));
   mtf.output = NULL;
   
-  if (!mtf_free (&mtf))
-    ok = false;
-  return ok ? CMD_SUCCESS : CMD_CASCADING_FAILURE;
+  return mtf_free (&mtf) ? CMD_SUCCESS : CMD_CASCADING_FAILURE;
   
  error:
+  proc_close (ds);
   mtf_free (&mtf);
   return CMD_CASCADING_FAILURE;
 }
 
-/* Repeats 2...7 an arbitrary number of times. */
-static bool
-mtf_processing_finish (void *mtf_, const struct dataset *ds)
-{
-  struct mtf_proc *mtf = mtf_;
-  struct mtf_file *iter;
-
-  /* Find the active file and delete it. */
-  for (iter = mtf->head; iter; iter = iter->next)
-    if (iter->handle == NULL)
-      {
-        if (!mtf_delete_file_in_place (mtf, &iter))
-          NOT_REACHED ();
-        break;
-      }
-  
-  while (mtf->head && mtf->head->type == MTF_FILE)
-    if (!mtf_processing (NULL, mtf, ds))
-      return false;
-
-  return true;
-}
-
 /* Return a string in a static buffer describing V's variable type and
    width. */
 static char *
@@ -1221,7 +1176,7 @@ mtf_close_file (struct mtf_file *file)
   any_reader_close (file->reader);
   if (file->handle != NULL)
     dict_destroy (file->dict);
-  case_destroy (&file->input);
+  case_destroy (&file->input_storage);
   free (file->in_name);
   free (file);
   return ok;
@@ -1291,21 +1246,24 @@ mtf_delete_file_in_place (struct mtf_pro
   return mtf_close_file (f);
 }
 
-/* Read a record from every input file except the active file.
+/* Read a record from every input file.
    Returns true if successful, false if an I/O error occurred. */
 static bool
-mtf_read_nonactive_records (void *mtf_)
+mtf_read_records (struct mtf_proc *mtf, struct dataset *ds)
 {
-  struct mtf_proc *mtf = mtf_;
   struct mtf_file *iter, *next;
   bool ok = true;
 
   for (iter = mtf->head; ok && iter != NULL; iter = next)
     {
       next = iter->next;
-      if (iter->handle && !any_reader_read (iter->reader, &iter->input)) 
-        if (!mtf_delete_file_in_place (mtf, &iter))
-          ok = false;
+      if (iter->handle
+          ? !any_reader_read (iter->reader, iter->input)
+          : !proc_read (ds, &iter->input)) 
+        {
+          if (!mtf_delete_file_in_place (mtf, &iter))
+            ok = false; 
+        }
     }
   return ok;
 }
@@ -1314,46 +1272,66 @@ mtf_read_nonactive_records (void *mtf_)
    if A == B, 1 if A > B. */
 static inline int
 mtf_compare_BY_values (struct mtf_proc *mtf,
-                       struct mtf_file *a, struct mtf_file *b,
-                       const struct ccase *c)
+                       struct mtf_file *a, struct mtf_file *b)
 {
-  const struct ccase *ca = case_is_null (&a->input) ? c : &a->input;
-  const struct ccase *cb = case_is_null (&b->input) ? c : &b->input;
-  assert ((a == NULL) + (b == NULL) + (c == NULL) <= 1);
-  return case_compare_2dict (ca, cb, a->by, b->by, mtf->by_cnt);
+  return case_compare_2dict (a->input, b->input, a->by, b->by, mtf->by_cnt);
 }
 
 /* Perform one iteration of steps 3...7 above.
    Returns true if successful, false if an I/O error occurred. */
 static bool
-mtf_processing (const struct ccase *c, void *mtf_, const struct dataset *ds UNUSED)
+mtf_processing (struct mtf_proc *mtf, struct dataset *ds)
 {
-  struct mtf_proc *mtf = mtf_;
-
-  /* Do we need another record from the active file? */
-  bool read_active_file;
+  struct mtf_file *min_head, *min_tail; /* Files with minimum BY values. */
+  struct mtf_file *max_head, *max_tail; /* Files with non-minimum BYs. */
+  struct mtf_file *iter, *next;
 
-  assert (mtf->head != NULL);
-  if (mtf->head->type == MTF_TABLE)
-    return true;
-  
-  do
+  /* 3. Find the FILE input record(s) that have minimum BY
+     values.  Store all the values from these input records into
+     the output record. */
+  min_head = min_tail = mtf->head;
+  max_head = max_tail = NULL;
+  for (iter = mtf->head->next; iter && iter->type == MTF_FILE;
+       iter = iter->next) 
     {
-      struct mtf_file *min_head, *min_tail; /* Files with minimum BY values. */
-      struct mtf_file *max_head, *max_tail; /* Files with non-minimum BYs. */
-      struct mtf_file *iter, *next;
-
-      read_active_file = false;
+      int cmp = mtf_compare_BY_values (mtf, min_head, iter);
+      if (cmp < 0) 
+        {
+          if (max_head)
+            max_tail = max_tail->next_min = iter;
+          else
+            max_head = max_tail = iter;
+        }
+      else if (cmp == 0) 
+        min_tail = min_tail->next_min = iter;
+      else /* cmp > 0 */
+        {
+          if (max_head)
+            {
+              max_tail->next_min = min_head;
+              max_tail = min_tail;
+            }
+          else
+            {
+              max_head = min_head;
+              max_tail = min_tail;
+            }
+          min_head = min_tail = iter;
+        }
+    }
+      
+  /* 4. For every TABLE, read another record as long as the BY
+     values on the TABLE's input record are less than the FILEs'
+     BY values.  If an exact match is found, store all the values
+     from the TABLE input record into the output record. */
+  for (; iter != NULL; iter = next)
+    {
+      assert (iter->type == MTF_TABLE);
       
-      /* 3. Find the FILE input record(s) that have minimum BY
-         values.  Store all the values from these input records into
-         the output record. */
-      min_head = min_tail = mtf->head;
-      max_head = max_tail = NULL;
-      for (iter = mtf->head->next; iter && iter->type == MTF_FILE;
-	   iter = iter->next) 
+      next = iter->next;
+      for (;;) 
         {
-          int cmp = mtf_compare_BY_values (mtf, min_head, iter, c);
+          int cmp = mtf_compare_BY_values (mtf, min_head, iter);
           if (cmp < 0) 
             {
               if (max_head)
@@ -1361,142 +1339,97 @@ mtf_processing (const struct ccase *c, v
               else
                 max_head = max_tail = iter;
             }
-          else if (cmp == 0) 
-	    min_tail = min_tail->next_min = iter;
+          else if (cmp == 0)
+            min_tail = min_tail->next_min = iter;
           else /* cmp > 0 */
             {
-              if (max_head)
-                {
-                  max_tail->next_min = min_head;
-                  max_tail = min_tail;
-                }
-              else
-                {
-                  max_head = min_head;
-                  max_tail = min_tail;
-                }
-              min_head = min_tail = iter;
+              if (iter->handle
+                  ? any_reader_read (iter->reader, iter->input)
+                  : proc_read (ds, &iter->input))
+                continue;
+              if (!mtf_delete_file_in_place (mtf, &iter))
+                return false;
             }
+          break;
         }
-      
-      /* 4. For every TABLE, read another record as long as the BY
-	 values on the TABLE's input record are less than the FILEs'
-	 BY values.  If an exact match is found, store all the values
-	 from the TABLE input record into the output record. */
-      for (; iter != NULL; iter = next)
-	{
-	  assert (iter->type == MTF_TABLE);
-      
-	  next = iter->next;
-          for (;;) 
-            {
-              int cmp = mtf_compare_BY_values (mtf, min_head, iter, c);
-              if (cmp < 0) 
-                {
-                  if (max_head)
-                    max_tail = max_tail->next_min = iter;
-                  else
-                    max_head = max_tail = iter;
-                }
-              else if (cmp == 0)
-                min_tail = min_tail->next_min = iter;
-              else /* cmp > 0 */
-                {
-                  if (iter->handle == NULL)
-                    return true;
-                  if (any_reader_read (iter->reader, &iter->input))
-                    continue;
-                  if (!mtf_delete_file_in_place (mtf, &iter))
-                    return false;
-                }
-              break;
-            }
-	}
+    }
 
-      /* Next sequence number. */
-      mtf->seq_num++;
+  /* Next sequence number. */
+  mtf->seq_num++;
 
-      /* Store data to all the records we are using. */
-      if (min_tail)
-	min_tail->next_min = NULL;
-      for (iter = min_head; iter; iter = iter->next_min)
-	{
-	  int i;
+  /* Store data to all the records we are using. */
+  if (min_tail)
+    min_tail->next_min = NULL;
+  for (iter = min_head; iter; iter = iter->next_min)
+    {
+      int i;
 
-	  for (i = 0; i < dict_get_var_cnt (iter->dict); i++)
-	    {
-	      struct variable *v = dict_get_var (iter->dict, i);
-              struct variable *mv = get_master (v);
-              size_t mv_index = mv ? var_get_dict_index (mv) : 0;
+      for (i = 0; i < dict_get_var_cnt (iter->dict); i++)
+        {
+          struct variable *v = dict_get_var (iter->dict, i);
+          struct variable *mv = get_master (v);
+          size_t mv_index = mv ? var_get_dict_index (mv) : 0;
 	  
-	      if (mv != NULL && mtf->seq_nums[mv_index] != mtf->seq_num) 
-                {
-                  const struct ccase *record
-                    = case_is_null (&iter->input) ? c : &iter->input;
-                  union value *out = case_data_rw (&mtf->mtf_case, mv);
-
-                  mtf->seq_nums[mv_index] = mtf->seq_num;
-                  if (var_is_numeric (v))
-                    out->f = case_num (record, v);
-                  else
-                    memcpy (out->s, case_str (record, v), var_get_width (v));
-                } 
-            }
-          if (iter->in_var != NULL)
-            case_data_rw (&mtf->mtf_case, iter->in_var)->f = 1.;
+          if (mv != NULL && mtf->seq_nums[mv_index] != mtf->seq_num) 
+            {
+              const struct ccase *record = iter->input;
+              union value *out = case_data_rw (&mtf->mtf_case, mv);
 
-          if (iter->type == MTF_FILE && iter->handle == NULL)
-            read_active_file = true;
-	}
+              mtf->seq_nums[mv_index] = mtf->seq_num;
+              if (var_is_numeric (v))
+                out->f = case_num (record, v);
+              else
+                memcpy (out->s, case_str (record, v), var_get_width (v));
+            } 
+        }
+      if (iter->in_var != NULL)
+        case_data_rw (&mtf->mtf_case, iter->in_var)->f = 1.;
+    }
 
-      /* Store missing values to all the records we're not
-         using. */
-      if (max_tail)
-	max_tail->next_min = NULL;
-      for (iter = max_head; iter; iter = iter->next_min)
-	{
-	  int i;
+  /* Store missing values to all the records we're not using. */
+  if (max_tail)
+    max_tail->next_min = NULL;
+  for (iter = max_head; iter; iter = iter->next_min)
+    {
+      int i;
 
-	  for (i = 0; i < dict_get_var_cnt (iter->dict); i++)
-	    {
-	      struct variable *v = dict_get_var (iter->dict, i);
-              struct variable *mv = get_master (v);
-              size_t mv_index = mv ? var_get_dict_index (mv) : 0;
+      for (i = 0; i < dict_get_var_cnt (iter->dict); i++)
+        {
+          struct variable *v = dict_get_var (iter->dict, i);
+          struct variable *mv = get_master (v);
+          size_t mv_index = mv ? var_get_dict_index (mv) : 0;
 
-	      if (mv != NULL && mtf->seq_nums[mv_index] != mtf->seq_num) 
-                {
-                  union value *out = case_data_rw (&mtf->mtf_case, mv);
-                  mtf->seq_nums[mv_index] = mtf->seq_num;
+          if (mv != NULL && mtf->seq_nums[mv_index] != mtf->seq_num) 
+            {
+              union value *out = case_data_rw (&mtf->mtf_case, mv);
+              mtf->seq_nums[mv_index] = mtf->seq_num;
 
-                  if (var_is_numeric (v))
-                    out->f = SYSMIS;
-                  else
-                    memset (out->s, ' ', var_get_width (v));
-                }
+              if (var_is_numeric (v))
+                out->f = SYSMIS;
+              else
+                memset (out->s, ' ', var_get_width (v));
             }
-          if (iter->in_var != NULL)
-            case_data_rw (&mtf->mtf_case, iter->in_var)->f = 0.;
-	}
+        }
+      if (iter->in_var != NULL)
+        case_data_rw (&mtf->mtf_case, iter->in_var)->f = 0.;
+    }
 
-      /* 5. Write the output record. */
-      casefile_append (mtf->output, &mtf->mtf_case);
+  /* 5. Write the output record. */
+  casefile_append (mtf->output, &mtf->mtf_case);
 
-      /* 6. Read another record from each input file FILE and TABLE
-	 that we stored values from above.  If we come to the end of
-	 one of the input files, remove it from the list of input
-	 files. */
-      for (iter = min_head; iter && iter->type == MTF_FILE; iter = next)
-	{
-	  next = iter->next_min;
-	  if (iter->reader != NULL
-              && !any_reader_read (iter->reader, &iter->input))
-            if (!mtf_delete_file_in_place (mtf, &iter))
-              return false;
-	}
+  /* 6. Read another record from each input file FILE and TABLE
+     that we stored values from above.  If we come to the end of
+     one of the input files, remove it from the list of input
+     files. */
+  for (iter = min_head; iter && iter->type == MTF_FILE; iter = next)
+    {
+      next = iter->next_min;
+      if (iter->reader != NULL
+          ? !any_reader_read (iter->reader, iter->input)
+          : !proc_read (ds, &iter->input))
+        if (!mtf_delete_file_in_place (mtf, &iter))
+          return false;
     }
-  while (!read_active_file
-         && mtf->head != NULL && mtf->head->type == MTF_FILE);
-
   return true;
 }
 
Index: src/language/data-io/inpt-pgm.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/inpt-pgm.c,v
retrieving revision 1.21
diff -u -p -r1.21 inpt-pgm.c
--- src/language/data-io/inpt-pgm.c	15 Dec 2006 00:16:02 -0000	1.21
+++ src/language/data-io/inpt-pgm.c	17 Dec 2006 06:28:27 -0000
@@ -66,10 +66,10 @@ enum value_init_type
 struct input_program_pgm 
   {
     struct trns_chain *trns_chain;
+    enum trns_result restart;
 
+    bool inited_case;           /* Did one-time case initialization? */
     size_t case_nr;             /* Incremented by END CASE transformation. */
-    write_case_func *write_case;/* Called by END CASE. */
-    write_case_data wc_data;    /* Aux data used by END CASE. */
 
     enum value_init_type *init; /* How to initialize each `union value'. */
     size_t init_cnt;            /* Number of elements in inp_init. */
@@ -152,6 +152,10 @@ cmd_input_program (struct lexer *lexer, 
   inp->trns_chain = proc_capture_transformations (ds);
   trns_chain_finalize (inp->trns_chain);
 
+  inp->restart = TRNS_CONTINUE;
+  inp->inited_case = false;
+  inp->case_nr = 1;
+
   /* Figure out how to initialize each input case. */
   inp->init_cnt = dict_get_next_value_idx (dataset_dict (ds));
   inp->init = xnmalloc (inp->init_cnt, sizeof *inp->init);
@@ -175,7 +179,7 @@ cmd_input_program (struct lexer *lexer, 
   inp->case_size = dict_get_case_size (dataset_dict (ds));
 
   proc_set_source (ds, 
-		  create_case_source (&input_program_source_class, inp));
+                   create_case_source (&input_program_source_class, inp));
 
   return CMD_SUCCESS;
 }
@@ -237,28 +241,45 @@ clear_case (const struct input_program_p
       }
 }
 
-/* Executes each transformation in turn on a `blank' case.
-   Returns true if successful, false if an I/O error occurred. */
+/* Returns true if STATE is valid given the transformations that
+   are allowed within INPUT PROGRAM. */
+static bool
+is_valid_state (enum trns_result state) 
+{
+  return (state == TRNS_CONTINUE
+          || state == TRNS_ERROR
+          || state == TRNS_END_FILE
+          || state >= 0);
+}
+
+/* Reads one case into C.
+   Returns true if successful, false at end of file or if an
+   I/O error occurred. */
 static bool
-input_program_source_read (struct case_source *source,
-                           struct ccase *c,
-                           write_case_func *write_case,
-                           write_case_data wc_data)
+input_program_source_read (struct case_source *source, struct ccase *c)
 {
   struct input_program_pgm *inp = source->aux;
 
-  inp->case_nr = 1;
-  inp->write_case = write_case;
-  inp->wc_data = wc_data;
-  for (init_case (inp, c); ; clear_case (inp, c))
+  if (!inp->inited_case)
+    {
+      init_case (inp, c);
+      inp->inited_case = true;
+    }
+
+  do
     {
-      enum trns_result result = trns_chain_execute (inp->trns_chain, c,
-                                                    &inp->case_nr);
-      if (result == TRNS_ERROR)
+      assert (is_valid_state (inp->restart));
+      if (inp->restart == TRNS_ERROR || inp->restart == TRNS_END_FILE)
         return false;
-      else if (result == TRNS_END_FILE)
-        return true;
+
+      clear_case (inp, c);
+      inp->restart = trns_chain_execute (inp->trns_chain, inp->restart,
+                                         c, &inp->case_nr);
+      assert (is_valid_state (inp->restart));
     }
+  while (inp->restart < 0);
+
+  return true;
 }
 
 static void
@@ -272,13 +293,16 @@ destroy_input_program (struct input_prog
     }
 }
 
-/* Destroys an INPUT PROGRAM source. */
-static void
+/* Destroys the source.
+   Returns true if successful read, false if an I/O occurred
+   during destruction or previously. */
+static bool
 input_program_source_destroy (struct case_source *source)
 {
   struct input_program_pgm *inp = source->aux;
-
+  bool ok = inp->restart != TRNS_ERROR;
   destroy_input_program (inp);
+  return ok;
 }
 
 static const struct case_source_class input_program_source_class =
@@ -300,16 +324,12 @@ cmd_end_case (struct lexer *lexer, struc
 
 /* Sends the current case as the source's output. */
 int
-end_case_trns_proc (void *inp_, struct ccase *c, casenumber case_nr UNUSED)
+end_case_trns_proc (void *inp_, struct ccase *c UNUSED,
+                    casenumber case_nr UNUSED)
 {
   struct input_program_pgm *inp = inp_;
-
-  if (!inp->write_case (inp->wc_data))
-    return TRNS_ERROR;
-
   inp->case_nr++;
-  clear_case (inp, c);
-  return TRNS_CONTINUE;
+  return TRNS_END_CASE;
 }
 
 /* REREAD transformation. */
Index: src/language/stats/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/ChangeLog,v
retrieving revision 1.36
diff -u -p -r1.36 ChangeLog
--- src/language/stats/ChangeLog	16 Dec 2006 20:57:15 -0000	1.36
+++ src/language/stats/ChangeLog	17 Dec 2006 06:28:27 -0000
@@ -1,3 +1,24 @@
+Sat Dec 16 22:26:44 2006  Ben Pfaff  <blp@gnu.org>
+
+	Make it possible to pull cases from the active file with a
+	function call, instead of requiring indirection through a callback
+	function.
+
+	* aggregate.c (cmd_aggregate): Take advantage of new procedure
+	interface.
+	(agr_to_active_file): Removed.
+	(presorted_agr_to_sysfile): Removed.
+
+	* autorecode.c (cmd_autorecode): Take advantage of new procedure
+	interface.
+	(autorecode_proc_func): Removed.
+
+	* flip.c (struct flip_pgm): New members to allow conformance with
+	new case_source_class interface.
+	(cmd_flip): Adapt to new case_source_class interface.
+	(flip_source_read): Ditto.
+	(flip_source_destroy): Ditto.
+
 Sat Dec 16 12:54:27 2006  Ben Pfaff  <blp@gnu.org>
 
 	* rank.q (rank_custom_variables): Allow grouping variables to be
Index: src/language/stats/aggregate.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/aggregate.c,v
retrieving revision 1.24
diff -u -p -r1.24 aggregate.c
--- src/language/stats/aggregate.c	16 Dec 2006 03:40:41 -0000	1.24
+++ src/language/stats/aggregate.c	17 Dec 2006 06:28:28 -0000
@@ -164,12 +164,6 @@ static bool aggregate_single_case (struc
 				   const struct ccase *input,
 				   struct ccase *output);
 static void dump_aggregate_info (struct agr_proc *agr, struct ccase *output);
-
-/* Aggregating to the active file. */
-static bool agr_to_active_file (const struct ccase *, void *aux, const struct dataset *);
-
-/* Aggregating to a system file. */
-static bool presorted_agr_to_sysfile (const struct ccase *, void *aux, const struct dataset *);
 
 /* Parsing. */
 
@@ -272,6 +266,8 @@ cmd_aggregate (struct lexer *lexer, stru
   /* Output to active file or external file? */
   if (out_file == NULL) 
     {
+      struct ccase *c;
+      
       /* The active file will be replaced by the aggregated data,
          so TEMPORARY is moot. */
       proc_cancel_temporary_transformations (ds);
@@ -286,9 +282,16 @@ cmd_aggregate (struct lexer *lexer, stru
       if (agr.sink->class->open != NULL)
         agr.sink->class->open (agr.sink);
       proc_set_sink (ds, 
-		     create_case_sink (&null_sink_class, 
-				       dict, NULL));
-      if (!procedure (ds, agr_to_active_file, &agr))
+		     create_case_sink (&null_sink_class, dict, NULL));
+      proc_open (ds);
+      while (proc_read (ds, &c))
+        if (aggregate_single_case (&agr, c, &agr.agr_case)) 
+          if (!agr.sink->class->write (agr.sink, &agr.agr_case)) 
+            {
+              proc_close (ds);
+              goto error; 
+            }
+      if (!proc_close (ds))
         goto error;
       if (agr.case_cnt > 0) 
         {
@@ -300,8 +303,7 @@ cmd_aggregate (struct lexer *lexer, stru
       dict_destroy (dict);
       dataset_set_dict (ds, agr.dict);
       agr.dict = NULL;
-      proc_set_source (ds, 
-		       agr.sink->class->make_source (agr.sink));
+      proc_set_source (ds, agr.sink->class->make_source (agr.sink));
       free_case_sink (agr.sink);
     }
   else
@@ -338,7 +340,17 @@ cmd_aggregate (struct lexer *lexer, stru
       else 
         {
           /* Active file is already sorted. */
-          if (!procedure (ds, presorted_agr_to_sysfile, &agr))
+          struct ccase *c;
+          
+          proc_open (ds);
+          while (proc_read (ds, &c))
+            if (aggregate_single_case (&agr, c, &agr.agr_case)) 
+              if (!any_writer_write (agr.writer, &agr.agr_case)) 
+                {
+                  proc_close (ds);
+                  goto error;
+                }
+          if (!proc_close (ds))
             goto error;
         }
       
@@ -1102,31 +1114,3 @@ initialize_aggregate_info (struct agr_pr
 	}
     }
 }
-
-/* Aggregate each case as it comes through.  Cases which aren't needed
-   are dropped.
-   Returns true if successful, false if an I/O error occurred. */
-static bool
-agr_to_active_file (const struct ccase *c, void *agr_, const struct dataset *ds UNUSED)
-{
-  struct agr_proc *agr = agr_;
-
-  if (aggregate_single_case (agr, c, &agr->agr_case)) 
-    return agr->sink->class->write (agr->sink, &agr->agr_case);
-
-  return true;
-}
-
-/* Aggregate the current case and output it if we passed a
-   breakpoint. */
-static bool
-presorted_agr_to_sysfile (const struct ccase *c, void *agr_, 
-			  const struct dataset *ds UNUSED) 
-{
-  struct agr_proc *agr = agr_;
-
-  if (aggregate_single_case (agr, c, &agr->agr_case)) 
-    return any_writer_write (agr->writer, &agr->agr_case);
-  
-  return true;
-}
